package com.mapmyindia.sdk.flutter.direction

import android.app.Activity
import android.content.Context
import android.content.Intent
import androidx.appcompat.app.AppCompatActivity;

import android.os.Bundle;
import android.util.Log
import android.widget.Toast
import com.google.gson.Gson
import com.google.gson.GsonBuilder
import com.mapmyindia.sdk.direction.ui.DirectionCallback
import com.mapmyindia.sdk.direction.ui.DirectionFragment
import com.mapmyindia.sdk.direction.ui.model.DirectionOptions
import com.mapmyindia.sdk.direction.ui.model.DirectionPoint
import com.mmi.services.api.directions.models.DirectionsResponse


/**
 ** Created by Saksham on 23-04-2021.
 **/
class DirectionActivity : AppCompatActivity() {
    lateinit var directionFragment: DirectionFragment

    var directionOptions: DirectionOptions? = null
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_direction)


        if(intent != null) {
            directionOptions = intent.getParcelableExtra("com.mapmyindia.sdk.flutter.direction.DIRECTION_OPTION")
            intent.extras?.clear()
        }
        if(directionOptions == null) {
            directionOptions = DirectionOptions.builder().build();
        }
        directionFragment = DirectionFragment.newInstance(directionOptions!!)
        supportFragmentManager.beginTransaction().replace(R.id.fragment_container, directionFragment, DirectionFragment::class.java.simpleName)
                .commit()


        directionFragment.setDirectionCallback(object : DirectionCallback {
            override fun onStartNavigation(origin: DirectionPoint?, destination: DirectionPoint?, waypoints: MutableList<DirectionPoint>?, directionsResponse: DirectionsResponse?, selectedIndex: Int) {
                val waypointList= ArrayList<DirectionPoint>()

                if (waypoints != null) {
                    for (point in waypoints){
                        waypointList.add(point)
                    }
                }

                MapmyIndiaDirectionsSettings.getInstance().destination = destination
                MapmyIndiaDirectionsSettings.getInstance().origin = origin
                MapmyIndiaDirectionsSettings.getInstance().wayPoints = waypointList
                MapmyIndiaDirectionsSettings.getInstance().directionsResponse = directionsResponse
                MapmyIndiaDirectionsSettings.getInstance().selectedIndex = selectedIndex
                //val sharedPreferences=getSharedPreferences("response", Context.MODE_PRIVATE).edit()
                // sharedPreferences.putString("directionsResponse",directionsResponse?.toJson()).apply()

                setResult(Activity.RESULT_OK)
                finish()
            }

            override fun onCancel() {
                setResult(Activity.RESULT_CANCELED)
                finish()
            }

        })
    }



}