
import 'package:flutter/material.dart';
import 'package:flutter_colorpicker/flutter_colorpicker.dart';
import 'package:grouped_buttons/grouped_buttons.dart';
import 'package:mapmyindia_direction_plugin/mapmyindia_direction_plugin.dart';
import 'package:mapmyindia_direction_plugin_example/DirectionSettings.dart';
import 'package:supercharged/supercharged.dart';
import 'package:fluttertoast/fluttertoast.dart';

class SettingWidget extends StatefulWidget {
  @override
  _SettingWidgetState createState() => _SettingWidgetState();
}

class _SettingWidgetState extends State<SettingWidget> {
  bool isShowStartNavigation = DirectionSettings().showStartNavigation;
  bool isShowSteps = DirectionSettings().showSteps;
  bool isShowAlternativeRoutes = DirectionSettings().showAlternative;
  bool isTokenizeAddress = DirectionSettings().tokenizeAddress;
  bool isSaveHistory = DirectionSettings().saveHistory;

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
        home: Scaffold(
        appBar: AppBar(
        title: const Text("Direction Widget Settings"),
    ),
    body: SingleChildScrollView(
      child: Padding(
        padding: EdgeInsets.all(10),
        child: Column(
          children: [
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                Text("Destination"),
                Column(
                  children: [
                    InkWell(
                      onTap: (){
                        showDialog(
                          context: context,
                          builder: (_) => AlertDialog(
                            title: const Text('set Destination!'),
                            content: SingleChildScrollView(
                              child:Column(
                                children: [
                                  Row(
                                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                                    children: [
                                      Text("Eloc"),
                                      Container(
                                          width: 150,
                                          child: TextFormField(
                                            initialValue:
                                            DirectionSettings().eloc==null?"":DirectionSettings().eloc,
                                            onChanged: (text) {
                                              DirectionSettings().eloc =
                                                  text;
                                            },
                                            decoration: InputDecoration(
                                              border: OutlineInputBorder(),
                                              hintText: "Eloc",
                                            ),
                                          )),
                                    ],
                                  ),
                                  Row(
                                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                                    children: [
                                      Text("Place Name"),
                                      Container(
                                          width: 150,
                                          child: TextFormField(
                                            initialValue:
                                            DirectionSettings().placeName==null?"":DirectionSettings().placeName,
                                            onChanged: (text) {
                                              DirectionSettings().placeName =
                                                  text;
                                            },
                                            decoration: InputDecoration(
                                              border: OutlineInputBorder(),
                                              hintText: "Place name",
                                            ),
                                          )),
                                    ],
                                  ),
                                  Row(
                                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                                    children: [
                                      Text("Place Address"),
                                      Container(
                                          width: 150,
                                          child: TextFormField(
                                            initialValue:
                                            DirectionSettings().placeAddress==null?"":DirectionSettings().placeAddress,

                                            onChanged: (text) {
                                              DirectionSettings().placeAddress =
                                                  text;
                                            },
                                            keyboardType: TextInputType.text,
                                            decoration: InputDecoration(
                                              border: OutlineInputBorder(),
                                              hintText: "Place Address",
                                            ),
                                          )),
                                    ],
                                  ),
                                ],
                              ),
                            ),
                            actions: <Widget>[
                              FlatButton(
                                child: const Text('Done'),
                                onPressed: () {
                                  if(DirectionSettings().placeName!= null && DirectionSettings().placeAddress!= null&& DirectionSettings().eloc!=null){
                                    DirectionSettings().dLng=null;
                                    DirectionSettings().dLat=null;
                                    Navigator.of(context,rootNavigator: true).pop();
                                  }else{
                                    Fluttertoast.showToast(
                                        msg: "Please fill all fields",
                                        toastLength: Toast.LENGTH_SHORT,
                                        gravity: ToastGravity.BOTTOM,
                                        timeInSecForIosWeb: 1,
                                        backgroundColor: Colors.red,
                                        textColor: Colors.white,
                                        fontSize: 16.0
                                    );
                                  }

                                },
                              ),
                            ],
                          ),
                        );
                      },
                      child:
                      Text("ELoc"),
                    ),
                    InkWell(
                      onTap: (){
                        showDialog(
                          context: context,
                          builder: (_) => AlertDialog(
                            title: const Text('set Destination!'),
                            content: SingleChildScrollView(
                              child:Column(
                                children: [
                                  Row(
                                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                                    children: [
                                      Text("Location"),
                                      Container(
                                          width: 60,
                                          child: TextFormField(
                                            initialValue:
                                            DirectionSettings().dLng==null?"":DirectionSettings().dLng,
                                            onChanged: (text) {
                                              DirectionSettings().dLng =
                                                  text;
                                            },
                                            decoration: InputDecoration(
                                              border: OutlineInputBorder(),
                                              hintText: "Longitude",
                                            ),
                                          )),
                                      Container(
                                          width: 60,
                                          child: TextFormField(
                                            initialValue:
                                            DirectionSettings().dLat==null?"":DirectionSettings().dLat,
                                            onChanged: (text) {
                                              DirectionSettings().dLat =
                                                  text;
                                            },
                                            decoration: InputDecoration(
                                              border: OutlineInputBorder(),
                                              hintText: "latitude",
                                            ),
                                          )),
                                    ],
                                  ),
                                  Row(
                                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                                    children: [
                                      Text("Place Name"),
                                      Container(
                                          width: 150,
                                          child: TextFormField(
                                            initialValue:
                                            DirectionSettings().placeName==null?"":DirectionSettings().placeName,
                                            onChanged: (text) {
                                              DirectionSettings().placeName =
                                                  text;
                                            },
                                            decoration: InputDecoration(
                                              border: OutlineInputBorder(),
                                              hintText: "Place name",
                                            ),
                                          )),
                                    ],
                                  ),
                                  Row(
                                    mainAxisAlignment: MainAxisAlignment.spaceBetween,
                                    children: [
                                      Text("Place Address"),
                                      Container(
                                          width: 150,
                                          child: TextFormField(
                                            initialValue:
                                            DirectionSettings().placeAddress==null?"":DirectionSettings().placeAddress,

                                            onChanged: (text) {
                                              DirectionSettings().placeAddress =
                                                  text;
                                            },
                                            keyboardType: TextInputType.text,
                                            decoration: InputDecoration(
                                              border: OutlineInputBorder(),
                                              hintText: "Place Address",
                                            ),
                                          )),
                                    ],
                                  ),
                                ],
                              ),
                            ),
                            actions: <Widget>[
                              FlatButton(
                                child: const Text('Done'),
                                onPressed: () {
                                  if(DirectionSettings().placeName!= null && DirectionSettings().placeAddress!= null&& DirectionSettings().dLat!=null&& DirectionSettings().dLng!=null){
                                     DirectionSettings().eloc=null;
                                    Navigator.of(context,rootNavigator: true).pop();
                                  }else{
                                    Fluttertoast.showToast(
                                        msg: "Please fill all fields",
                                        toastLength: Toast.LENGTH_SHORT,
                                        gravity: ToastGravity.BOTTOM,
                                        timeInSecForIosWeb: 1,
                                        backgroundColor: Colors.red,
                                        textColor: Colors.white,
                                        fontSize: 16.0
                                    );
                                  }

                                },
                              ),
                            ],
                          ),
                        );
                      },
                      child:
                      Text("Location"),
                    )
                  ],
                )
              ],
            ),
            Divider(
              color: Colors.grey,
              height: 5,
            ),
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                Text("Show Start Navigation"),
                Switch(
                  onChanged: (bool value) {
                    DirectionSettings().showStartNavigation = value;
                    print(value);
                    setState(() {
                      isShowStartNavigation = value;
                    });
                  },
                  value: isShowStartNavigation,
                  activeColor: Colors.blue,
                  activeTrackColor: Colors.yellow,
                  inactiveThumbColor: Colors.redAccent,
                  inactiveTrackColor: Colors.orange,
                )
              ],
            ),
            Divider(
              color: Colors.grey,
              height: 5,
            ),
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                Text("Show Alternative Routes"),
                Switch(
                  onChanged: (bool value) {
                    DirectionSettings().showAlternative = value;
                    print(value);
                    setState(() {
                      isShowAlternativeRoutes = value;
                    });
                  },
                  value: isShowAlternativeRoutes,
                  activeColor: Colors.blue,
                  activeTrackColor: Colors.yellow,
                  inactiveThumbColor: Colors.redAccent,
                  inactiveTrackColor: Colors.orange,
                )
              ],
            ),
            Divider(
              color: Colors.grey,
              height: 5,
            ),
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                Text("Show Steps"),
                Switch(
                  onChanged: (bool value) {
                    DirectionSettings().showSteps = value;
                    print(value);
                    setState(() {
                      isShowSteps = value;
                    });
                  },
                  value: isShowSteps,
                  activeColor: Colors.blue,
                  activeTrackColor: Colors.yellow,
                  inactiveThumbColor: Colors.redAccent,
                  inactiveTrackColor: Colors.orange,
                )
              ],
            ),
            Divider(
              color: Colors.grey,
              height: 5,
            ),
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                Flexible(child: Text("Resources"),flex: 1,),
                Flexible(
                  flex: 1,
                  child: RadioButtonGroup(
                      labels: <String>["Route", "Route ETA", "Route Traffic",],
                      picked: getLabel(DirectionSettings()
                          .resource),
                      onSelected: (String selected) {
                        setState(() {});
                        switch (selected) {
                          case "Route":
                            DirectionSettings().resource = DirectionCriteria.RESOURCE_ROUTE;
                            break;
                          case "Route ETA":
                            DirectionSettings().resource = DirectionCriteria.RESOURCE_ROUTE_ETA;
                            break;
                          case "Route Traffic":
                            DirectionSettings().resource = DirectionCriteria.RESOURCE_ROUTE_TRAFFIC;
                            break;
                        }
                      }),
                )
              ],
            ),
            Divider(
              color: Colors.grey,
              height: 5,
            ),
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                Flexible(child: Text("Profile"),flex: 1,),
                Flexible(
                  flex: 1,
                  child: RadioButtonGroup(
                      labels: <String>["Driving", "Walking", "Biking","Trucking"],
                      picked: getLabel(DirectionSettings()
                          .profile),
                      onSelected: (String selected) {
                        setState(() {});
                        switch (selected) {
                          case "Driving":
                            DirectionSettings()
                                .profile =
                                DirectionCriteria.PROFILE_DRIVING;
                            break;
                          case "Walking":
                            DirectionSettings()
                                .profile = DirectionCriteria.PROFILE_WALKING;
                            break;
                          case "Biking":
                            DirectionSettings()
                                .profile = DirectionCriteria.PROFILE_BIKING;
                            break;
                          case "Trucking":
                            DirectionSettings()
                                .profile = DirectionCriteria.PROFILE_TRUCKING;
                            break;
                        }
                      }),
                )
              ],
            ),
            Divider(
              color: Colors.grey,
              height: 5,
            ),
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                Flexible(child: Text("OverView"),flex: 1,),
                Flexible(
                  flex: 1,
                  child: RadioButtonGroup(
                      labels: <String>["Full", "None", "Simplified",],
                      picked: getLabel(DirectionSettings()
                          .overView),
                      onSelected: (String selected) {
                        setState(() {});
                        switch (selected) {
                          case "Full":
                            DirectionSettings()
                                .overView =
                                DirectionCriteria.OVERVIEW_FULL;
                            break;
                          case "None":
                            DirectionSettings()
                                .overView = DirectionCriteria.OVERVIEW_FALSE;
                            break;
                          case "Simplified":
                            DirectionSettings()
                                .overView = DirectionCriteria.OVERVIEW_SIMPLIFIED;
                            break;
                        }
                      }),
                )
              ],
            ),
            Divider(
              color: Colors.grey,
              height: 5,
            ),
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                Flexible(child: Text("Excludes"),flex: 1,),
                Flexible(
                  flex: 1,
                  child: CheckboxGroup(
                    labels: <String>["Ferry", "Motorway", "Toll",],
                    checked: getCheckedList(DirectionSettings().excludes),
                    onSelected: (List<String> checked){
                      setState(() {
                      });
                      List<String> attrList = [];
                      for(String value in checked){
                        attrList.add(createArray(value)!);
                      }
                      DirectionSettings().excludes= attrList;
                    },
                  ),
                )
              ],
            ),
            Divider(
              color: Colors.grey,
              height: 5,
            ),
            Text("Search Place Options",style: TextStyle( fontWeight: FontWeight.bold,fontSize: 20),),
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                Text("Tokenize Address"),
                Switch(
                  onChanged: (bool value) {
                    DirectionSettings().tokenizeAddress = value;
                    print(value);
                    setState(() {
                      isTokenizeAddress = value;
                    });
                  },
                  value: isTokenizeAddress,
                  activeColor: Colors.blue,
                  activeTrackColor: Colors.yellow,
                  inactiveThumbColor: Colors.redAccent,
                  inactiveTrackColor: Colors.orange,
                )
              ],
            ),
            Divider(
              color: Colors.grey,
              height: 5,
            ),
            Row(
              mainAxisAlignment: MainAxisAlignment.spaceBetween,
              children: [
                Text("Save History"),
                Switch(
                  onChanged: (bool value) {
                    DirectionSettings().saveHistory = value;
                    print(value);
                    setState(() {
                      isSaveHistory = value;
                    });
                  },
                  value: isSaveHistory,
                  activeColor: Colors.blue,
                  activeTrackColor: Colors.yellow,
                  inactiveThumbColor: Colors.redAccent,
                  inactiveTrackColor: Colors.orange,
                )
              ],
            ),
            Divider(
              color: Colors.grey,
              height: 5,
            ),
            Padding(
              padding: EdgeInsets.only(top: 5,bottom: 5),
              child: Row(
                mainAxisAlignment: MainAxisAlignment.spaceBetween,
                children: [
                  Text("History Count"),
                  Container(
                      width: 80,
                      child: TextFormField(
                        initialValue:
                        DirectionSettings().historyCount==null?"":DirectionSettings().historyCount,
                        maxLength: 4,
                        onChanged: (text) {
                          DirectionSettings().historyCount =
                              text;
                        },
                        keyboardType: TextInputType.number,
                        decoration: InputDecoration(
                          border: OutlineInputBorder(),
                          hintText: "History Count",
                        ),
                      )),
                ],
              ),
            ),
            Divider(
              color: Colors.grey,
              height: 5,
            ),
            InkWell(
              onTap: (){
                showDialog(
                  context: context,
                  builder: (_) => AlertDialog(
                    title: const Text('Pick a color!'),
                    content: SingleChildScrollView(
                      child: BlockPicker(
                        pickerColor: DirectionSettings().backgroundColor.toColor(),
                        onColorChanged: (color) {
                          //var hex = '#${color.value.toRadixString(16)}';
                          //  print(color);
                          setState(() {
                            DirectionSettings().backgroundColor = color.toHex();
                          });


                        },
                      ),
                    ),
                    actions: <Widget>[
                      FlatButton(
                        child: const Text('Got it'),
                        onPressed: () {
                          Navigator.of(context,rootNavigator: true).pop();
                        },
                      ),
                    ],
                  ),
                );

              },
              child: Padding(
                padding: EdgeInsets.all(5),
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: [
                    Text("Background Color"),
                    Container(
                      height: 50,
                      width: 50,
                      decoration: BoxDecoration(
                          border: Border.all(color: Colors.grey),
                          color:DirectionSettings().backgroundColor.toColor(),
                          borderRadius: BorderRadius.circular(5)
                      ),
                    )
                  ],
                ),
              ),
            ),
            Divider(
              color: Colors.grey,
              height: 5,
            ),
            InkWell(
              onTap: (){
                showDialog(
                  context: context,
                  builder: (_) => AlertDialog(
                    title: const Text('Pick a color!'),
                    content: SingleChildScrollView(
                      child: BlockPicker(
                        pickerColor: DirectionSettings().toolbarColor.toColor(),
                        onColorChanged: (color) {
                          //var hex = '#${color.value.toRadixString(16)}';
                          //  print(color);
                          setState(() {
                            DirectionSettings().toolbarColor = color.toHex();
                          });


                        },
                      ),
                    ),
                    actions: <Widget>[
                      FlatButton(
                        child: const Text('Got it'),
                        onPressed: () {
                          Navigator.of(context,rootNavigator: true).pop();
                        },
                      ),
                    ],
                  ),
                );

              },
              child: Padding(
                padding: EdgeInsets.all(5),
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: [
                    Text("Toolbar Color"),
                    Container(
                      height: 50,
                      width: 50,
                      decoration: BoxDecoration(
                          border: Border.all(color: Colors.grey),
                          color:DirectionSettings().toolbarColor.toColor(),
                          borderRadius: BorderRadius.circular(5)
                      ),
                    )
                  ],
                ),
              ),
            ),
            Divider(
              color: Colors.grey,
              height: 5,
            ),
            InkWell(
              onTap: (){
                showDialog(
                  context: context,
                  builder: (_) => AlertDialog(
                    title: const Text('Pick a color!'),
                    content: SingleChildScrollView(
                      child: BlockPicker(
                        pickerColor: DirectionSettings().toolbarTintColor.toColor(),
                        onColorChanged: (color) {
                          //var hex = '#${color.value.toRadixString(16)}';
                          //  print(color);
                          setState(() {
                            DirectionSettings().toolbarTintColor = color.toHex();
                          });


                        },
                      ),
                    ),
                    actions: <Widget>[
                      FlatButton(
                        child: const Text('Got it'),
                        onPressed: () {
                          Navigator.of(context,rootNavigator: true).pop();
                        },
                      ),
                    ],
                  ),
                );

              },
              child: Padding(
                padding: EdgeInsets.all(5),
                child: Row(
                  mainAxisAlignment: MainAxisAlignment.spaceBetween,
                  children: [
                    Text("Toolbar Tint Color"),
                    Container(
                      height: 50,
                      width: 50,
                      decoration: BoxDecoration(
                          border: Border.all(color: Colors.grey),
                          color:DirectionSettings().toolbarTintColor.toColor(),
                          borderRadius: BorderRadius.circular(5)
                      ),
                    )
                  ],
                ),
              ),
            ),
            Divider(
              color: Colors.grey,
              height: 5,
            ),
            Padding(
              padding: EdgeInsets.only(top: 5,bottom: 5),
              child: Row(
                mainAxisAlignment: MainAxisAlignment.spaceBetween,
                children: [
                  Text("Zoom"),
                  Container(
                      width: 80,
                      child: TextFormField(
                        initialValue:
                        DirectionSettings().zoom==null?"":DirectionSettings().zoom,
                        maxLength: 4,
                        onChanged: (text) {
                          DirectionSettings().zoom =
                              text;
                        },
                        keyboardType: TextInputType.number,
                        decoration: InputDecoration(
                          border: OutlineInputBorder(),
                          hintText: "zoom",
                        ),
                      )),
                ],
              ),
            ),
            Divider(
              color: Colors.grey,
              height: 5,
            ),
            Padding(
              padding: EdgeInsets.only(top: 5,bottom: 5),
              child: Row(
                mainAxisAlignment: MainAxisAlignment.spaceBetween,
                children: [
                  Text("Location"),
                  Container(
                      width: 80,
                      child: TextFormField(
                        initialValue:
                        DirectionSettings().longitude==null?"":DirectionSettings().longitude,
                        maxLength: 4,
                        onChanged: (text) {
                          DirectionSettings().longitude =
                              text;
                        },
                        keyboardType: TextInputType.number,
                        decoration: InputDecoration(
                          border: OutlineInputBorder(),
                          hintText: "Longitude",
                        ),
                      )),
                  Container(
                      width: 80,
                      child: TextFormField(
                        initialValue:
                        DirectionSettings().latitude==null?"":DirectionSettings().latitude,
                        maxLength: 4,
                        onChanged: (text) {
                          DirectionSettings().latitude =
                              text;
                        },
                        keyboardType: TextInputType.number,
                        decoration: InputDecoration(
                          border: OutlineInputBorder(),
                          hintText: "latitude",
                        ),
                      )),
                ],
              ),
            ),
            Divider(
              color: Colors.grey,
              height: 5,
            ),
            Padding(
              padding: EdgeInsets.only(top: 5,bottom: 5),
              child: Row(
                mainAxisAlignment: MainAxisAlignment.spaceBetween,
                children: [
                  Text("Filter"),
                  Container(
                      width: 150,
                      child: TextFormField(
                        initialValue:
                        DirectionSettings().filter==null?"":DirectionSettings().filter,
                        onChanged: (text) {
                          DirectionSettings().filter =
                              text;
                        },
                        keyboardType: TextInputType.number,
                        decoration: InputDecoration(
                          border: OutlineInputBorder(),
                          hintText: "filter",
                        ),
                      )),
                ],
              ),
            ),
            Divider(
              color: Colors.grey,
              height: 5,
            ),
          ],
        ),
      ),
    )


    ));
  }


  String? getLabel(dynamic data) {
    switch (data) {
      case DirectionCriteria.RESOURCE_ROUTE:
        return "Route";
      case DirectionCriteria.RESOURCE_ROUTE_ETA:
        return "Route ETA";
      case DirectionCriteria.RESOURCE_ROUTE_TRAFFIC:
        return "Route Traffic";
      case DirectionCriteria.PROFILE_DRIVING:
        return "Driving";
      case DirectionCriteria.PROFILE_WALKING:
        return "Walking";
      case DirectionCriteria.PROFILE_BIKING:
        return "Biking";
      case DirectionCriteria.PROFILE_TRUCKING:
        return "Trucking";
      case DirectionCriteria.OVERVIEW_FULL:
        return "Full";
      case DirectionCriteria.OVERVIEW_FALSE:
        return "None";
      case DirectionCriteria.OVERVIEW_SIMPLIFIED:
        return "Simplified";
      case DirectionCriteria.EXCLUDE_FERRY:
        return "Ferry";
      case DirectionCriteria.EXCLUDE_MOTORWAY:
        return "Motorway";
      case DirectionCriteria.EXCLUDE_TOLL:
        return "Toll";

    }
    return null;
  }

  String? createArray(String data){
    switch(data){
      case "Ferry":
        return DirectionCriteria.EXCLUDE_FERRY;
      case "Motorway":
        return DirectionCriteria.EXCLUDE_MOTORWAY;
      case "Toll":
        return DirectionCriteria.EXCLUDE_TOLL;
    }
  }

  List<String> getCheckedList(dynamic data){
         List<String > list = data as List<String>;
         List<String> resultList = [];
         for(String value in list){
           resultList.add(getLabel(value)!);
         }
         return resultList;
  }
}

extension ColorX on Color {
  String toHex() => '#${(value & 0xFFFFFF).toRadixString(16).padLeft(6,'0').toUpperCase()}';
}