part of mapmyindia_direction_plugin;

class DirectionOptions {
  final bool? showAlternative;
  final bool? showProfileOption;
  final bool? showStartNavigation;
  final String? resource;
  final String? profile;
  final bool? steps;
  final String? overview;
  final int? theme;
  final List<String>? annotation;
  final List<String>? excludes;
  final PlaceOptions? searchPlaceOption;
  final DirectionPoint? destination;

  DirectionOptions({
    this.showAlternative,
    this.showProfileOption,
    this.showStartNavigation,
    this.resource,
    this.profile,
    this.steps,
    this.overview,
    this.theme,
    this.annotation,
    this.excludes,
    this.searchPlaceOption,
    this.destination,
  });

  Map<String, dynamic> toMap() {
    final Map<String, dynamic> optionsMap = <String, dynamic>{};

    void addIfNonNull(String fieldName, dynamic value) {
      if (value != null) {
        optionsMap[fieldName] = value;
      }
    }

    addIfNonNull('showAlternative', showAlternative);
    addIfNonNull('showProfileOption', showProfileOption);
    addIfNonNull('showStartNavigation', showStartNavigation);
    addIfNonNull('resource', resource);
    addIfNonNull('profile', profile);
    addIfNonNull('steps', steps);
    addIfNonNull('overview', overview);
    addIfNonNull('theme', theme);
    addIfNonNull('annotation', annotation);
    addIfNonNull('excludes', excludes);
    addIfNonNull('searchPlaceOption', searchPlaceOption?.toMap());
    addIfNonNull('destination', destination?.toMap());
    return optionsMap;
  }
}
