part of mapmyindia_direction_plugin;

class PlaceOptions {
  final bool? enableTextSearch;
  final String? filter;
  final String? hint;
  final int? historyCount;
  final int? limit;
  final String? pod;
  final String? backgroundColor;
  final String? statusbarColor;
  final String? toolbarColor;
  final String? toolbarTintColor;
  final bool? saveHistory;
  final bool? tokenizeAddress;
  final bool? userAddedLocationEnable;
  final double? zoom;
  final LatLng? location;

  //ios
  final String? primaryTextColor;
  final String? tintColor;
  final String? tableCellSeparatorColor;
  final String? primaryTextHighlightColor;

  PlaceOptions(
      {this.enableTextSearch,
      this.filter,
      this.hint,
      this.historyCount,
      this.limit,
      this.pod,
      this.saveHistory,
      this.backgroundColor,
      this.statusbarColor,
      this.toolbarColor,
      this.toolbarTintColor,
      this.tokenizeAddress,
      this.userAddedLocationEnable,
      this.zoom,
      this.location,

      //ios
      this.primaryTextColor,
      this.tintColor,
      this.tableCellSeparatorColor,
      this.primaryTextHighlightColor});

  Map<String, dynamic> toMap() {
    final Map<String, dynamic> optionsMap = <String, dynamic>{};

    void addIfNonNull(String fieldName, dynamic value) {
      if (value != null) {
        optionsMap[fieldName] = value;
      }
    }

    addIfNonNull('enableTextSearch', enableTextSearch);
    addIfNonNull('filter', filter);
    addIfNonNull('hint', hint);
    addIfNonNull('historyCount', historyCount);
    addIfNonNull('limit', limit);
    addIfNonNull('pod', pod);
    addIfNonNull('saveHistory', saveHistory);
    addIfNonNull('backgroundColor', backgroundColor);
    addIfNonNull('statusbarColor', statusbarColor);
    addIfNonNull('toolbarColor', toolbarColor);
    addIfNonNull('toolbarTintColor', toolbarTintColor);
    addIfNonNull('tokenizeAddress', tokenizeAddress);
    addIfNonNull('userAddedLocationEnable', userAddedLocationEnable);
    addIfNonNull('zoom', zoom);
    if (location != null) {
      addIfNonNull('location', location?.toJson());
    }

    //ios
    addIfNonNull('primaryTextColor', primaryTextColor);
    addIfNonNull('tintColor', tintColor);
    addIfNonNull('tableCellSeparatorColor', tableCellSeparatorColor);
    addIfNonNull('primaryTextHighlightColor', primaryTextHighlightColor);

    return optionsMap;
  }
}
