part of mapmyindia_direction_plugin;

class DirectionPoint {
  final String? eLoc;
  final String placeName;
  final String placeAddress;
  final LatLng? location;

  DirectionPoint(this.placeName, this.placeAddress, {this.eLoc, this.location})
      : assert(eLoc != null || location != null);

  Map<String, dynamic> toMap() {
    final Map<String, dynamic> optionsMap = <String, dynamic>{};

    void addIfNonNull(String fieldName, dynamic value) {
      if (value != null) {
        optionsMap[fieldName] = value;
      }
    }

    optionsMap['placeName'] = placeName;
    optionsMap['placeAddress'] = placeAddress;
    addIfNonNull('eLoc', eLoc);
    addIfNonNull('location', location?.toJson());
    return optionsMap;
  }
}
